#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include "primitives.h"
class nodule
	{
	// This class definition acts as the heart of the network simulator
	// It sets up definitions for both nodes and links, defining the
	// mean time between failure, and mean time between recoveries, as well
	// as providing functions for handling the "death" and "recovery"
	// phases of the simulator.
	// Further, churn for each element, or "nodule" is maintained here
	// through the defined churn variables.
	// Each of these elements is kept in a routing matrix and are accessed
	// as such. The order of broadcasts is determined in the main portion
	// of the network simulator, under the initiator function call which 
	// randomly orders the events and assigns times accordingly over a 
	// range of twenty six seconds to thirty three seconds.
 
	public:
	float deathtime;
	float phoenix;
	float delay;

	int churninga,churna100thou;
	int churna10bill;	
	char churnabig;
	char deadtxmission;	
	short mtbf;  //mean time between failures in seconds thru 33000
	short mtbr;  //mean time between resurrections in seconds	
	char dead;
	char txmit;
	short updatnde;
//*** TRY TO TAKE THIS OUT
	char waitonnode;
	char reaperrand;

	double length;
	double orilength;      // original value of 1-hop matrix, for use
			     // with resurrection function. Assuming 
			     // it is desirable to not have the simulator
			     // confused under heavy failures	
	nodule ()
		{};
	setvalues (int i, short perflag, int infinit,int noedges,short node)
		{
		// for tallying how much churn an individual node undergoes
		deadtxmission=-1;
		length=i;
		churninga=0;
		churna100thou=0;
		churna10bill=0;
		churnabig=0; 
		orilength=length;

		// NEXT HOP INITIALIZATION:
		updatnde=-1;
		
		// ****************************************
		// WANT TO DEFINE ONE SET OF MTBF AND MTBR
		// THE VALUES OF MTBF AND MTBR DO NOT
		// REPRESENT THE ACTUAL MEAN-TIMES BETWEEN FAILURE
		// AND RECOVERY, BUT ARE THE MAX VALUE POSSIBLE.
		// THE ACTUAL MTBF AND MTBR WOULD BE HALF THE ASSIGNED
		// VALUE BELOW.
		// --ONE SET FOR LINKS, and ONE FOR NODES
		       if (node)
			{
			// NODE FAILURE & RECOVERY TIME
			mtbf=1000;
			mtbr=1000;
			}
		      else
			{
			// LINK FAILURE & RECOVERY TIME
			mtbf=1000;
			mtbr=1000;
			}
		
		// compute this node/link's time to drop
		// and recover
			deathtime=(rand())%int(mtbf)+1;
			phoenix=(rand())%int(mtbr)+1;	
		// ****************************************

		// if set to 1, this will indicate that nodes and links
		// cannot drop based on the mtbf, it is desired to cause
		// manual drops.
		reaperrand=perflag;
		// if link must wait for a node to come back up before being
		// able to update, waitonnode will be set to 1
		waitonnode=0;
		}

// below function serves to cause nodes to die based on a
// MEAN-TIME BETWEEN FAILURES set time. Needs to be passed
// the current simulation wall-clock time to determine
// node death and/or resurrection
	void deadfunction(int upordown,float timeadd,short node)
		{
//cout<<" PLAYING WITH DEATH FUNCTION "<<endl; 
	// ONLY USE RANDOM NODE-DEATH FUNCTIONS IF
        // RANDOM DEATH IS IN USE AND NOT
        // WHEN IN MANUAL USAGE.
	// NEED TO INCREMENT TIMES AS TIME MOVES FORWARD
//cout<<" times: "<<clocktime<<" vs. time2die: "<<deathtime<<endl;
        if ((reaperrand==0)&&(!waitonnode))
		    {
		if ((upordown==1)&&(dead==0)&&((length!=0)||(node)))
			{
			length=infinity;
			dead=1;
			// Need to adjust time to revive
		        // And for next death-time 
			phoenix+=deathtime;
			deathtime=deathtime+phoenix;
			//cout<<" phantom voice says: revival/deathtime is now: "<<phoenix<<" "<<deathtime<<endl;
			}
		else if ((upordown==0))
			 //(clocktime>=phoenix)
			// Use timeadd to correct MTBF when coming up
			// used for links associated with a node kill
			{
		//cout<<" LIVE "<<endl;
			length=orilength;
			dead=0;
			// Adjust deathtime
			//deathtime=clocktime+deathtime;
			deathtime+=phoenix;
			phoenix=deathtime+phoenix;
			if (timeadd!=-1)
				{
				deathtime+=timeadd;
				phoenix+=timeadd;
				}
		//	cout<<"voice of the redeemer says: revival and deathtime:"<<phoenix<<" "<<deathtime<<endl;
			}
		else if ((upordown==3))
			{
			// there was a premature attempted recovery. 
			// should adjust
			// recovery time.
			phoenix+=deathtime;
			}
		     }
		}

	void churn(int x)
        {
        if (x>0)
        {
        churninga++;
        if (churninga==100000)
                {
                churninga=0;
                churna100thou++;
                        if (churna100thou==100000)
                                {
                                churna100thou=0;
                                churna10bill++;
                                        if (churna10bill==1000000)
                                                {
                                                 churna10bill=0;
                                                 churnabig++;
                                                }
                                }
                }
        }
        else
        {
        churninga--;
        if (churninga<0)
                {
                churninga=0;
                churna100thou--;
                        if (churna100thou<0)
                                {
                                churna100thou=0;
                                churna10bill--;
                                        if (churna10bill<0)
                                                {
                                                churna10bill=0;
                                                churnabig--;
                                                        if (churnabig<0)
                                                                churnabig=0;
                                                }
                                }
                }
        }
        }
			

	void sink(int up)
		{
		if ((length!=infinity)&&(up==0))
			{
			length=infinity;
			dead=1;
			}
		else if (up==1)
			{
			length=orilength;
			updatnde=-1;
			dead=0;
//cout<<"This thing's length is: "<<length<<" 2and its original length was:"<<orilength<<endl;
			}
		}
	
	void update(int l)
		{
		// FOR USE WITH MANUAL NODE KILLING
		dead=l;
		}
	};

	
	
		
